KMainWindow Class Reference

`#include <kmainwindow.h>`

Inheritance diagram for KMainWindow:

## Public Types

enum | CreationFlags { NoDCOPObject = 1 }
enum | StandardWindowOptions { ToolBar = 1, Keys = 2, StatusBar = 4, Save = 8, Create = 16 }
Public Types inherited from KXMLGUIClient
enum | ReverseStateChange { StateNoReverse, StateReverse }

## Public Slots

int | configureToolbars ()
virtual void | setCaption (const QString &caption)
virtual void | setCaption (const QString &caption, bool modified)
virtual void | setPlainCaption (const QString &caption)
void | appHelpActivated (void)
virtual void | slotStateChanged (const QString &newstate)
void | slotStateChanged (const QString &newstate, KXMLGUIClient::ReverseStateChange)
void | setSettingsDirty ()

## Public Member Functions

| KMainWindow (QWidget *parent=0, const char *name=0, WFlags f=WType_TopLevel|WDestructiveClose)
| KMainWindow (int cflags, QWidget *parent=0, const char *name=0, WFlags f=WType_TopLevel|WDestructiveClose)
virtual | ~KMainWindow ()
KPopupMenu * | helpMenu (const QString &aboutAppText=QString::null, bool showWhatsThis=true)
KPopupMenu * | customHelpMenu (bool showWhatsThis=true)
virtual void | show ()
virtual void | hide ()
bool | restore (int number, bool show=true)
virtual KXMLGUIFactory * | guiFactory ()
void | createGUI (const QString &xmlfile=QString::null, bool _conserveMemory=true)
void | setHelpMenuEnabled (bool showHelpMenu=true)
bool | isHelpMenuEnabled ()
bool | hasMenuBar ()
KMenuBar * | menuBar ()
KStatusBar * | statusBar ()
KToolBar * | toolBar (const char *name=0)
QPtrListIterator< KToolBar > | toolBarIterator ()
KAccel * | accel ()
void | setFrameBorderWidth (int)
void | setAutoSaveSettings (const QString &groupName=QString::fromLatin1("MainWindow"), bool saveWindowSize=true)
void | resetAutoSaveSettings ()
bool | autoSaveSettings () const
QString | autoSaveGroup () const
void | applyMainWindowSettings (KConfig *config, const QString &groupName, bool force)
void | applyMainWindowSettings (KConfig *config, const QString &groupName=QString::null)
void | saveMainWindowSettings (KConfig *config, const QString &groupName=QString::null)
void | setStandardToolBarMenuEnabled (bool enable)
bool | isStandardToolBarMenuEnabled () const
void | createStandardStatusBarAction ()
void | setupGUI (int options=ToolBar|Keys|StatusBar|Save|Create, const QString &xmlfile=QString::null)
void | setupGUI (QSize defaultSize, int options=ToolBar|Keys|StatusBar|Save|Create, const QString &xmlfile=QString::null)
KAction * | toolBarMenuAction ()
void | setupToolbarMenuActions ()
virtual void | finalizeGUI (KXMLGUIClient *client)
void | finalizeGUI (bool force)
bool | initialGeometrySet () const
void | ignoreInitialGeometry ()
QSize | sizeForCentralWidgetSize (QSize size) KDE_DEPRECATED
virtual void | setIcon (const QPixmap &)
Public Member Functions inherited from KXMLGUIBuilder
| KXMLGUIBuilder (QWidget *widget)
KXMLGUIClient * | builderClient () const
void | setBuilderClient (KXMLGUIClient *client)
KInstance * | builderInstance () const
void | setBuilderInstance (KInstance *instance)
QWidget * | widget ()
virtual QStringList | containerTags () const
virtual QWidget * | createContainer (QWidget *parent, int index, const QDomElement &element, int &id)
virtual void | removeContainer (QWidget *container, QWidget *parent, QDomElement &element, int id)
virtual QStringList | customTags () const
virtual int | createCustomElement (QWidget *parent, int index, const QDomElement &element)
virtual void | removeCustomElement (QWidget *parent, int id)
Public Member Functions inherited from KXMLGUIClient
| KXMLGUIClient ()
| KXMLGUIClient (KXMLGUIClient *parent)
virtual | ~KXMLGUIClient ()
KAction * | action (const char *name) const
virtual KAction * | action (const QDomElement &element) const
virtual KActionCollection * | actionCollection () const
virtual KInstance * | instance () const
virtual QDomDocument | domDocument () const
virtual QString | xmlFile () const
virtual QString | localXMLFile () const
void | setXMLGUIBuildDocument (const QDomDocument &doc)
QDomDocument | xmlguiBuildDocument () const
void | setFactory (KXMLGUIFactory *factory)
KXMLGUIFactory * | factory () const
KXMLGUIClient * | parentClient () const
void | insertChildClient (KXMLGUIClient *child)
void | removeChildClient (KXMLGUIClient *child)
const QPtrList< KXMLGUIClient > * | childClients ()
void | setClientBuilder (KXMLGUIBuilder *builder)
KXMLGUIBuilder * | clientBuilder () const
void | reloadXML ()
void | plugActionList (const QString &name, const QPtrList< KAction > &actionList)
void | unplugActionList (const QString &name)
void | addStateActionEnabled (const QString &state, const QString &action)
void | addStateActionDisabled (const QString &state, const QString &action)
StateChange | getActionsToChangeForState (const QString &state)
void | beginXMLPlug (QWidget *)
void | endXMLPlug ()
void | prepareXMLUnplug (QWidget *)

## Static Public Member Functions

static bool | canBeRestored (int number)
static const QString | classNameOfToplevel (int number)
static QPtrList< KMainWindow > * | getMemberList ()
Static Public Member Functions inherited from KXMLGUIClient
static QString | findMostRecentXMLFile (const QStringList &files, QString &doc)

## Static Public Attributes

static QPtrList< KMainWindow > * | memberList = 0L

## Protected Slots

void | saveNewToolbarConfig ()
virtual void | showAboutApplication ()
void | saveAutoSaveSettings ()

## Protected Member Functions

void | paintEvent (QPaintEvent *e)
void | childEvent (QChildEvent *e)
void | resizeEvent (QResizeEvent *e)
virtual void | closeEvent (QCloseEvent *)
virtual bool | queryExit ()
virtual bool | queryClose ()
virtual void | saveProperties (KConfig *)
virtual void | readProperties (KConfig *)
virtual void | saveGlobalProperties (KConfig *sessionConfig)
virtual void | readGlobalProperties (KConfig *sessionConfig)
void | savePropertiesInternal (KConfig *, int)
bool | readPropertiesInternal (KConfig *, int)
bool | settingsDirty () const
QString | settingsGroup () const
void | saveWindowSize (KConfig *config) const
void | restoreWindowSize (KConfig *config)
void | parseGeometry (bool parsewidth)
virtual void | virtual_hook (int id, void *data)
Protected Member Functions inherited from KXMLGUIClient
virtual void | setInstance (KInstance *instance)
virtual void | setXMLFile (const QString &file, bool merge=false, bool setXMLDoc=true)
virtual void | setLocalXMLFile (const QString &file)
virtual void | setXML (const QString &document, bool merge=false)
virtual void | setDOMDocument (const QDomDocument &document, bool merge=false)
virtual void | conserveMemory ()
virtual void | stateChanged (const QString &newstate, ReverseStateChange reverse=StateNoReverse)

## Friends

class | KMWSessionManaged

## Detailed Description

KDE top level main window

Top level widget that provides toolbars, a status line and a frame.

It should be used as a top level (parent-less) widget. It manages the geometry for all its children, including your main widget.

Normally, you will inherit from KMainWindow, then construct (or use some existing) widget as your main view. You can set only one main view.

You can add as many toolbars as you like. There can be only one menubar and only one statusbar.

The toolbars, menubar, and statusbar can be created by the KMainWindow and - unlike the old KMainWindow - may, but do not have to, be deleted by you. KMainWindow will handle that internally.

Height and width can be operated independently from each other. Simply define the minimum/maximum height/width of your main widget and KMainWindow will take this into account. For fixed size windows set your main widget to a fixed size.

Fixed aspect ratios (heightForWidth()) and fixed width widgets are not supported.

KMainWindow will set icon, mini icon and caption, which it gets from KApplication. It provides full session management, and will save its position, geometry and positions of toolbars and menubar on logout. If you want to save additional data, reimplement saveProperties() and (to read them again on next login) readProperties(). To save special data about your data, reimplement saveGlobalProperties(). To warn user that application or windows have unsaved data on close or logout, reimplement queryClose() and/or queryExit().

There are also kRestoreMainWindows convenience functions which can restore all your windows on next login.

Note that a KMainWindow per-default is created with the WDestructiveClose flag, i.e. it is automatically destroyed when the window is closed. If you do not want this behavior, specify 0 as widget flag in the constructor.

See also
  KApplication

Author
  Reginald Stadlbauer (reggi.nosp@m.e@kd.nosp@m.e.org) Stephan Kulow (coolo.nosp@m.@kde.nosp@m..org), Matthias Ettrich (ettri.nosp@m.ch@k.nosp@m.de.or.nosp@m.g), Chris Schlaeger (cs@kd.nosp@m.e.or.nosp@m.g), Sven Radej (radej.nosp@m.@kde.nosp@m..org). Maintained by Sven Radej (radej.nosp@m.@kde.nosp@m..org)

Definition at line 98 of file kmainwindow.h.

## Member Enumeration Documentation

enum KMainWindow::CreationFlags

Flags that can be passed in an argument to the constructor to change the behavior.

NoDCOPObject tells KMainWindow not to create a KMainWindowInterface. This can be useful in particular for inherited classes, which might want to create more specific dcop interfaces. It's a good idea to use KMainWindowInterface as the base class for such interfaces though (to provide the standard mainwindow functionality via DCOP).

Definition at line 148 of file kmainwindow.h.

enum KMainWindow::StandardWindowOptions

See also
  setupGUI()

Enumerator

ToolBar

adds action to show/hide the toolbar(s) and adds action to configure the toolbar(s).

See also
  setStandardToolBarMenuEnabled

Keys | adds action to show the key configure action.
StatusBar | adds action to show/hide the statusbar if the statusbar exists. See createStandardStatusBarAction

Save

auto-saves (and loads) the toolbar/menubar/statusbar settings and window size using the default name.

See setAutoSaveSettings

Typically you want to let the default window size be determined by the widgets size hints. Make sure that setupGUI() is called after all the widgets are created ( including setCentralWidget ) so the default size's will be correct. See setAutoSaveSettings for more information on this topic.

Create | calls createGUI() once ToolBar, Keys and Statusbar have been taken care of. See createGUI

Definition at line 546 of file kmainwindow.h.

## Constructor & Destructor Documentation

KMainWindow::KMainWindow | ( | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | WFlags | f = `WType_TopLevel | WDestructiveClose`
| ) |  |

Construct a main window.

Parameters

  parent | The widget parent. This is usually 0 but it may also be the window group leader. In that case, the KMainWindow becomes sort of a secondary window.

  name

  The object name. For session management and window management to work properly, all main windows in the application should have a different name. When passing 0 (the default), KMainWindow will create a unique name, but it's recommended to explicitly pass a window name that will also describe the type of the window. If there can be several windows of the same type, append '#' (hash) to the name, and KMainWindow will append numbers to make the names unique. For example, for a mail client which has one main window showing the mails and folders, and which can also have one or more windows for composing mails, the name for the folders window should be e.g. "mainwindow" and for the composer windows "composer#".

  f | Specify the widget flags. The default is WType_TopLevel and WDestructiveClose. TopLevel indicates that a main window is a toplevel window, regardless of whether it has a parent or not. DestructiveClose indicates that a main window is automatically destroyed when its window is closed. Pass 0 if you do not want this behavior.

See also
  http://doc.trolltech.com/3.2/qt.html#WidgetFlags-enum

KMainWindows must be created on the heap with 'new', like:

KMainWindow *kmw = new KMainWindow (...);

Definition at line 167 of file kmainwindow.cpp.

KMainWindow::KMainWindow | ( | int | cflags,
|  | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | WFlags | f = `WType_TopLevel | WDestructiveClose`
| ) |  |

Overloaded constructor which allows passing some KMainWindow::CreationFlags.

Since
  3.2

Definition at line 173 of file kmainwindow.cpp.

KMainWindow::~KMainWindow | ( |  | ) |

virtual

Destructor.

Will also destroy the toolbars, and menubar if needed.

Definition at line 314 of file kmainwindow.cpp.

## Member Function Documentation

KAccel * KMainWindow::accel | ( |  | ) |

Returns
  A KAccel instance bound to this mainwindow. Used automatically by KAction to make keybindings work in all cases.

Definition at line 1171 of file kmainwindow.cpp.

void KMainWindow::appHelpActivated | ( | void |  | ) |

slot

Open the help page for the application.

The application name is used as a key to determine what to display and the system will attempt to open <appName>/index.html.

This method is intended for use by a help button in the toolbar or components outside the regular help menu. Use helpMenu() when you want to provide access to the help system from the help menu.

Example (adding a help button to the first toolbar):

KIconLoader &loader = *KGlobal::iconLoader();
QPixmap pixmap = loader.loadIcon( "help" );
toolBar(0)->insertButton( pixmap, 0, SIGNAL(clicked()),
this, SLOT(appHelpActivated()), true, i18n("Help") );

Definition at line 600 of file kmainwindow.cpp.

void KMainWindow::applyMainWindowSettings | ( | KConfig * | config,
|  | const QString & | groupName,
|  | bool | force
| ) |  |

Read settings for statusbar, menubar and toolbar from their respective groups in the config file and apply them.

Parameters

  config | Config file to read the settings from.
  groupName | Group name to use. If not specified, the last used group name is used.
  force | if set, even default settings are re-applied

Definition at line 834 of file kmainwindow.cpp.

QString KMainWindow::autoSaveGroup | ( |  | ) | const

Returns
  the group used for setting-autosaving. Only meaningful if setAutoSaveSettings() was called. This can be useful for forcing a save or an apply, e.g. before and after using KEditToolbar.

Since
  3.1

Definition at line 1044 of file kmainwindow.cpp.

bool KMainWindow::autoSaveSettings | ( |  | ) | const

Returns
  the current autosave setting, i.e. true if setAutoSaveSettings() was called, false by default or if resetAutoSaveSettings() was called.

Since
  3.1

Definition at line 1039 of file kmainwindow.cpp.

bool KMainWindow::canBeRestored | ( | int | number | ) |

static

Session Management

Try to restore the toplevel widget as defined by the number (1..X).

If the session did not contain so high a number, the configuration is not changed and `false` returned.

That means clients could simply do the following:

if (kapp->isRestored()){
int n = 1;
while (KMainWindow::canBeRestored(n)){
(new childMW)->restore(n);
n++;
}
} else {
// create default application as usual
}

Note that QWidget::show() is called implicitly in restore.

With this you can easily restore all toplevel windows of your application.

If your application uses different kinds of toplevel windows, then you can use KMainWindow::classNameOfToplevel(n) to determine the exact type before calling the childMW constructor in the example from above.

If your client has only one kind of toplevel widgets (which should be pretty usual) then you should use the RESTORE-macro for backwards compatibility with 3.1 and 3.0 branches:

if (kapp->isRestored())
RESTORE(childMW)
else {
// create default application as usual
}

The macro expands to the term above but is easier to use and less code to write.

For new code or if you have more than one kind of toplevel widget (each derived from KMainWindow, of course), you can use the templated kRestoreMainWindows global functions:

if (kapp->isRestored())
kRestoreMainWindows< childMW1, childMW2, childMW3 >();
else {
// create default application as usual
}

Currently, these functions are provided for up to three template arguments. If you need more, tell us. To help you in deciding whether or not you can use kRestoreMainWindows, a define KDE_RESTORE_MAIN_WINDOWS_NUM_TEMPLATE_ARGS is provided.

See also
  restore()
  classNameOfToplevel()

Definition at line 352 of file kmainwindow.cpp.

const QString KMainWindow::classNameOfToplevel | ( | int | number | ) |

static

Returns the className() of the `number` of the toplevel window which should be restored.

This is only useful if your application uses different kinds of toplevel windows.

Definition at line 364 of file kmainwindow.cpp.

void KMainWindow::closeEvent | ( | QCloseEvent * | e | ) |

protected virtual

Reimplemented to call the queryClose() and queryExit() handlers.

We recommend that you reimplement the handlers rather than closeEvent(). If you do it anyway, ensure to call the base implementation to keep queryExit() running.

Definition at line 634 of file kmainwindow.cpp.

int KMainWindow::configureToolbars | ( |  | ) |

slot

Show a standard configure toolbar dialog.

This slot can be connected dirrectly to the action to configure shortcuts. This is very simple to do that by adding a single line

KStdAction::configureToolbars( guiFactory(), SLOT( configureToolbars() ),
actionCollection() );

Since
  3.3

Definition at line 431 of file kmainwindow.cpp.

void KMainWindow::createGUI | ( | const QString & | xmlfile = `QString::null`,
|  | bool | _conserveMemory = `true`
| ) |  |

Create a GUI given a local XML file.

If `xmlfile` is NULL, then it will try to construct a local XML filename like appnameui.rc where 'appname' is your app's name. If that file does not exist, then the XML UI code will only use the global (standard) XML file for the layout purposes.

Note that when passing true for the conserveMemory argument subsequent calls to guiFactory()->addClient/removeClient may not work as expected. Also retrieving references to containers like popup menus or toolbars using the container method will not work.

Parameters

  xmlfile | The local xmlfile (relative or absolute)
  _conserveMemory | Specify whether createGUI() should call KXMLGUIClient::conserveMemory() to free all memory allocated by the QDomDocument and by the KXMLGUIFactory.

Definition at line 491 of file kmainwindow.cpp.

void KMainWindow::createStandardStatusBarAction | ( |  | ) |

Sets whether KMainWindow should provide a menu that allows showing/hiding of the statusbar ( using KToggleStatusBarAction ).

The menu / menu item is implemented using xmlgui. It will be inserted in your menu structure in the 'Settings' menu.

Note that you should enable this feature before calling createGUI() ( or similar ).

If an application maintains the action on its own (i.e. never calls this function) a connection needs to be made to let KMainWindow know when that status (hidden/shown) of the statusbar has changed. For example: connect(action, SIGNAL(activated()), kmainwindow, SLOT(setSettingsDirty())); Otherwise the status (hidden/show) of the statusbar might not be saved by KMainWindow.

Since
  3.2

Definition at line 796 of file kmainwindow.cpp.

KPopupMenu * KMainWindow::customHelpMenu | ( | bool | showWhatsThis = `true` | ) |

Returns the help menu.

Creates a standard help menu if none exists yet.

It contains entries for the help system (activated by F1), an optional "What's This?" entry (activated by Shift F1), an application specific dialog box, and an "About KDE" dialog box. You must create the application specific dialog box yourself. When the "About application" menu entry is activated, a signal will trigger the showAboutApplication slot. See showAboutApplication for more information.

Example (adding a help menu to your application):

menuBar()->insertItem( i18n("&Help"), customHelpMenu() );

Parameters

  showWhatsThis | Set this to `false` if you do not want to include the "What's This" menu entry.

Returns
  A standard help menu.

Definition at line 341 of file kmainwindow.cpp.

void KMainWindow::finalizeGUI | ( | KXMLGUIClient * | client | ) |

virtual

Since
  3.1

Reimplemented from KXMLGUIBuilder.

Definition at line 1239 of file kmainwindow.cpp.

void KMainWindow::finalizeGUI | ( | bool | force | ) |

Definition at line 884 of file kmainwindow.cpp.

QPtrList< KMainWindow > * KMainWindow::getMemberList | ( |  | ) |

static

List of members of KMainWindow class.

Since
  3.4

Definition at line 1235 of file kmainwindow.cpp.

bool KMainWindow::hasMenuBar | ( |  | ) |

Returns true, if there is a menubar.

Since
  3.1

Definition at line 1066 of file kmainwindow.cpp.

KPopupMenu * KMainWindow::helpMenu | ( | const QString & | aboutAppText = `QString::null`,
|  | bool | showWhatsThis = `true`
| ) |  |

Retrieve the standard help menu.

It contains entires for the help system (activated by F1), an optional "What's This?" entry (activated by Shift F1), an application specific dialog box, and an "About KDE" dialog box.

Example (adding a standard help menu to your application):

KPopupMenu *help = helpMenu( <myTextString> );
menuBar()->insertItem( i18n("&Help"), help );

Parameters

  aboutAppText | The string that is used in the application specific dialog box. If you leave this string empty the information in the global KAboutData of the application will be used to make a standard dialog box.
  showWhatsThis | Set this to false if you do not want to include the "What's This" menu entry.

Returns
  A standard help menu.

Definition at line 324 of file kmainwindow.cpp.

void KMainWindow::hide | ( |  | ) |

virtual

Reimplementation of QMainWindow::hide()

Definition at line 391 of file kmainwindow.cpp.

void KMainWindow::ignoreInitialGeometry | ( |  | ) |

Used from Konqueror when reusing the main window.

Definition at line 985 of file kmainwindow.cpp.

bool KMainWindow::initialGeometrySet | ( |  | ) | const

Returns
  true if a -geometry argument was given on the command line, and this is the first window created (the one on which this option applies)

Definition at line 980 of file kmainwindow.cpp.

bool KMainWindow::isHelpMenuEnabled | ( |  | ) |

Return `true` when the help menu is enabled.

Definition at line 576 of file kmainwindow.cpp.

bool KMainWindow::isStandardToolBarMenuEnabled | ( |  | ) | const

Since
  3.1

Definition at line 791 of file kmainwindow.cpp.

KMenuBar * KMainWindow::menuBar | ( |  | ) |

Returns a pointer to the menu bar.

If there is no menu bar yet one will be created.

Definition at line 1071 of file kmainwindow.cpp.

void KMainWindow::parseGeometry | ( | bool | parsewidth | ) |

protected

parse the geometry from the geometry command line argument

Definition at line 279 of file kmainwindow.cpp.

bool KMainWindow::queryClose | ( |  | ) |

protected virtual

Called before the window is closed, either by the user or indirectly by the session manager.

The purpose of this function is to prepare the window in a way that it is safe to close it, i.e. without the user losing some data.

Default implementation returns true. Returning `false` will cancel the closing, and, if KApplication::sessionSaving() is true, it will also cancel KDE logout.

Reimplement this function to prevent the user from losing data. Example:

switch ( KMessageBox::warningYesNoCancel( this,
i18n("Save changes to document foo?")) ) {
case KMessageBox::Yes :
// save document here. If saving fails, return false;
return true;
case KMessageBox::No :
return true;
default: // cancel
return false;

Note that you should probably not actually close the document from within this method, as it may be called by the session manager before the session is saved. If the document is closed before the session save occurs, its location might not be properly saved. In addition, the session shutdown may be canceled, in which case the document should remain open.

See also
  queryExit()
  KApplication::sessionSaving()

Definition at line 669 of file kmainwindow.cpp.

bool KMainWindow::queryExit | ( |  | ) |

protected virtual

Called before the very last window is closed, either by the user or indirectly by the session manager.

It is not recommended to do any user interaction in this function other than indicating severe errors. Better ask the user on queryClose() (see below).

A typical usage of queryExit() is to write configuration data back. Note that the application may continue to run after queryExit() (the user may have canceled a shutdown), so you should not do any cleanups here. The purpose of queryExit() is purely to prepare the application (with possible user interaction) so it can safely be closed later (without user interaction).

If you need to do serious things on exit (like shutting a dial-up connection down), connect to the signal KApplication::shutDown().

      Default implementation returns @p true. Returning @p false will
      cancel the exiting. In the latter case, the last window will
      remain visible. If KApplication::sessionSaving() is true, refusing
      the exit will also cancel KDE logout.

      @see queryClose()
      @see KApplication::sessionSaving()

Definition at line 664 of file kmainwindow.cpp.

void KMainWindow::readGlobalProperties | ( | KConfig * | sessionConfig | ) |

protected virtual

The counterpart of saveGlobalProperties().

Read the application-specific properties in again.

Definition at line 678 of file kmainwindow.cpp.

virtual void KMainWindow::readProperties | ( | KConfig * |  | ) |

inline protected virtual

Read your instance-specific properties.

Definition at line 881 of file kmainwindow.h.

void KMainWindow::resetAutoSaveSettings | ( |  | ) |

Disable the auto-save-settings feature.

You don't normally need to call this, ever.

Definition at line 1032 of file kmainwindow.cpp.

bool KMainWindow::restore | ( | int | number,
|  | bool | show = `true`
| ) |  |

Restore the session specified by `number`.

Returns `false` if this fails, otherwise returns `true` and shows the window. You should call canBeRestored() first. If `show` is true (default), this widget will be shown automatically.

Definition at line 411 of file kmainwindow.cpp.

void KMainWindow::restoreWindowSize | ( | KConfig * | config | ) |

protected

For inherited classes Note that the group must be set before calling, and that a -geometry on the command line has priority.

Definition at line 934 of file kmainwindow.cpp.

void KMainWindow::saveAutoSaveSettings | ( |  | ) |

protected slot

This slot should only be called in case you reimplement closeEvent() and if you are using the "auto-save" feature.

In all other cases, setSettingsDirty() should be called instead to benefit from the delayed saving.

See also
  setAutoSaveSettings
  setSettingsDirty

Since
  3.2

Example:

void MyMainWindow::closeEvent( QCloseEvent *e )
{
// Save settings if auto-save is enabled, and settings have changed
if ( settingsDirty() && autoSaveSettings() )
saveAutoSaveSettings();
..
}

Definition at line 1049 of file kmainwindow.cpp.

void KMainWindow::saveGlobalProperties | ( | KConfig * | sessionConfig | ) |

protected virtual

Save your application-wide properties.

The function is invoked when the session manager requests your application to save its state.

This function is similar to saveProperties() but is only called for the very first main window, regardless how many main window are open.

Override it if you need to save other data about your documents on session end. sessionConfig is a config to which that data should be saved. Normally, you don't need this function. But if you want to save data about your documents that are not in opened windows you might need it.

Default implementation does nothing.

Definition at line 674 of file kmainwindow.cpp.

void KMainWindow::saveMainWindowSettings | ( | KConfig * | config,
|  | const QString & | groupName = `QString::null`
| ) |  |

Save settings for statusbar, menubar and toolbar to their respective groups in the config file `config`.

Parameters

  config | Config file to save the settings to.
  groupName | Group name to use. If not specified, the last used group name is used

Definition at line 716 of file kmainwindow.cpp.

void KMainWindow::saveNewToolbarConfig | ( |  | ) |

protected slot

Rebuilds the GUI after KEditToolbar changed the toolbar layout.

See also
  configureToolbars()

Definition at line 439 of file kmainwindow.cpp.

virtual void KMainWindow::saveProperties | ( | KConfig * |  | ) |

inline protected virtual

Save your instance-specific properties.

The function is invoked when the session manager requests your application to save its state.

You must not change the group of the `kconfig` object, since KMainWindow uses one group for each window. Please reimplement these function in childclasses.

Note: No user interaction is allowed in this function!

Definition at line 876 of file kmainwindow.h.

void KMainWindow::saveWindowSize | ( | KConfig * | config | ) | const

protected

For inherited classes Note that the group must be set before calling.

Definition at line 902 of file kmainwindow.cpp.

void KMainWindow::setAutoSaveSettings | ( | const QString & | groupName = `QString::fromLatin1("MainWindow")`,
|  | bool | saveWindowSize = `true`
| ) |  |

Call this to enable "auto-save" of toolbar/menubar/statusbar settings (and optionally window size).

If the *bars were moved around/shown/hidden when the window is closed, saveMainWindowSettings( KGlobal::config(), groupName ) will be called.

Parameters

  groupName | a name that identifies this "type of window". You can have several types of window in the same application.
  saveWindowSize | set it to true to include the window size when saving.

Typically, you will call setAutoSaveSettings() in your KMainWindow-inherited class constructor, and it will take care of restoring and saving automatically. Make sure you call this after all your *bars have been created.

To make sure that KMainWindow propertly obtains the default size of the window you should do the following:

- Remove hard coded resize() calls in the constructor or main, they should be removed in favor of letting the automatic resizing determine the default window size. Hard coded window sizes will be wrong for users that have big fonts, use different styles, long/small translations, large toolbars, and other factors.
- Put the setAutoSaveSettings ( or setupGUI() ) call after all widgets have been created and placed inside the main window (i.e. for 99% of apps setCentralWidget())
- Widgets that inherit from QWidget (like game boards) should overload "virtual QSize sizeHint() const;" to specify a default size rather than letting QWidget::adjust use the default size of 0x0.

Definition at line 1017 of file kmainwindow.cpp.

void KMainWindow::setCaption | ( | const QString & | caption | ) |

virtual slot

Makes a KDE compliant caption.

Parameters

  caption | Your caption. Do not include the application name in this string. It will be added automatically according to the KDE standard.

Definition at line 581 of file kmainwindow.cpp.

void KMainWindow::setCaption | ( | const QString & | caption,
|  | bool | modified
| ) |  |

virtual slot

Makes a KDE compliant caption.

Parameters

  caption | Your caption. Do not include the application name in this string. It will be added automatically according to the KDE standard.
  modified | Specify whether the document is modified. This displays an additional sign in the title bar, usually "**".

Definition at line 586 of file kmainwindow.cpp.

void KMainWindow::setHelpMenuEnabled | ( | bool | showHelpMenu = `true` | ) |

Enables the build of a standard help menu when calling createGUI().

The default behavior is to build one, you must call this function to disable it

Definition at line 571 of file kmainwindow.cpp.

void KMainWindow::setIcon | ( | const QPixmap & | p | ) |

virtual

Definition at line 1225 of file kmainwindow.cpp.

void KMainWindow::setPlainCaption | ( | const QString & | caption | ) |

virtual slot

Make a plain caption without any modifications.

Parameters

  caption | Your caption. This is the string that will be displayed in the window title.

Definition at line 591 of file kmainwindow.cpp.

void KMainWindow::setSettingsDirty | ( |  | ) |

slot

Apply a state change.

Enable and disable actions as defined in the XML rc file, can "reverse" the state (disable the actions which should be enabled, and vice-versa) if specified. Tell the main window that it should save its settings when being closed. This is part of the auto-save-settings feature. For everything related to toolbars this happens automatically, but you have to call setSettingsDirty() in the slot that toggles the visibility of the statusbar.

Definition at line 990 of file kmainwindow.cpp.

void KMainWindow::setStandardToolBarMenuEnabled | ( | bool | enable | ) |

Sets whether KMainWindow should provide a menu that allows showing/hiding the available toolbars ( using KToggleToolBarAction ) .

In case there is only one toolbar configured a simple 'Show <toolbar name here>' menu item is shown.

The menu / menu item is implemented using xmlgui. It will be inserted in your menu structure in the 'Settings' menu.

If your application uses a non-standard xmlgui resource file then you can specify the exact position of the menu / menu item by adding a <Merge name="StandardToolBarMenuHandler" /> line to the settings menu section of your resource file ( usually appname.rc ).

Note that you should enable this feature before calling createGUI() ( or similar ) . You enable/disable it anytime if you pass false to the conserveMemory argument of createGUI.

Since
  3.1

Definition at line 769 of file kmainwindow.cpp.

bool KMainWindow::settingsDirty | ( |  | ) | const

protected

For inherited classes.

Definition at line 1007 of file kmainwindow.cpp.

QString KMainWindow::settingsGroup | ( |  | ) | const

protected

For inherited classes.

Definition at line 1012 of file kmainwindow.cpp.

void KMainWindow::setupGUI | ( | int | options = `ToolBar | Keys | StatusBar | Save | Create`,
|  | const QString & | xmlfile = `QString::null`
| ) |  |

Configures the current windows and its actions in the typical KDE fashion.

The options are all enabled by default but can be turned off if desired through the params or if the prereqs don't exists.

Typically this function replaces createGUI().

See also
  StandardWindowOptions

Since
  3.3

Definition at line 445 of file kmainwindow.cpp.

void KMainWindow::setupGUI | ( | QSize | defaultSize,
|  | int | options = `ToolBar | Keys | StatusBar | Save | Create`,
|  | const QString & | xmlfile = `QString::null`
| ) |  |

Configures the current windows and its actions in the typical KDE fashion.

The options are all enabled by default but can be turned off if desired through the params or if the prereqs don't exists.

`defaultSize` The default size of the window

Typically this function replaces createGUI().

See also
  StandardWindowOptions

Since
  3.5

Definition at line 449 of file kmainwindow.cpp.

void KMainWindow::setupToolbarMenuActions | ( |  | ) |

for KToolBar

Since
  3.3.1

Definition at line 273 of file kmainwindow.cpp.

void KMainWindow::show | ( | void |  | ) |

virtual

Reimplementation of QMainWindow::show()

Definition at line 381 of file kmainwindow.cpp.

void KMainWindow::showAboutApplication | ( |  | ) |

protected virtual slot

This slot does nothing.

It must be reimplemented if you want to use a custom About Application dialog box. This slot is connected to the About Application entry in the menu returned by customHelpMenu.

Example:

void MyMainLevel::setupInterface()
{
..
menuBar()->insertItem( i18n("&Help"), customHelpMenu() );
..
}
void MyMainLevel::showAboutApplication()
{
<activate your custom dialog>
}

Definition at line 688 of file kmainwindow.cpp.

QSize KMainWindow::sizeForCentralWidgetSize | ( | QSize | size | ) |

Returns
  the size the mainwindow should have so that the central widget will be of `size`.

Deprecated:
  You normally don't need this, the recommended way to achieve a certain central widget size is as follows:
  - Override sizeHint() in the central widget so that it returns the desired size.
  - Call updateGeometry() in the central widget whenever the desired size changes. This ensures that the new sizeHint() is properly propagated to any parent layout.
  - Now call adjustSize() in the mainwindow to resize the mainwindow such that the central widget will become the desired size.

Definition at line 1183 of file kmainwindow.cpp.

void KMainWindow::slotStateChanged | ( | const QString & | newstate | ) |

virtual slot

Apply a state change.

Enable and disable actions as defined in the XML rc file

Since
  3.1

Definition at line 610 of file kmainwindow.cpp.

void KMainWindow::slotStateChanged | ( | const QString & | newstate,
|  | KXMLGUIClient::ReverseStateChange | reverse
| ) |  |

slot

Apply a state change.

Enable and disable actions as defined in the XML rc file, can "reverse" the state (disable the actions which should be enabled, and vice-versa) if specified.

Since
  3.1

Definition at line 618 of file kmainwindow.cpp.

KStatusBar * KMainWindow::statusBar | ( |  | ) |

Returns a pointer to the status bar.

If there is no status bar yet, one will be created.

Note that tooltips for kactions in actionCollection() are not automatically connected to this statusBar. See the KActionCollection documentation for more details.

See also
  KActionCollection

Definition at line 1083 of file kmainwindow.cpp.

KToolBar * KMainWindow::toolBar | ( | const char * | name = `0` | ) |

Returns a pointer to the toolbar with the specified name.

This refers to toolbars created dynamically from the XML UI framework. If the toolbar does not exist one will be created.

Parameters

  name | The internal name of the toolbar. If no name is specified "mainToolBar" is assumed.

Returns
  A pointer to the toolbar

Definition at line 1141 of file kmainwindow.cpp.

QPtrListIterator< KToolBar > KMainWindow::toolBarIterator | ( |  | ) |

Returns
  An iterator over the list of all toolbars for this window.

Definition at line 1156 of file kmainwindow.cpp.

KAction * KMainWindow::toolBarMenuAction | ( |  | ) |

Returns a pointer to the mainwindows action responsible for the toolbars menu.

Since
  3.1

Definition at line 264 of file kmainwindow.cpp.

## Member Data Documentation

QPtrList< KMainWindow > * KMainWindow::memberList = 0L

static

List of members of KMainWindow class.

Definition at line 385 of file kmainwindow.h.

The documentation for this class was generated from the following files:

- kmainwindow.h
- kmainwindow.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys